import { defineConfig } from 'rollup'
import { terser } from 'rollup-plugin-terser'

export default defineConfig([
    {
        input: 'src/utenti.js',
        external: ['alpinejs', 'fuse.js'], // libraries to not bundle
        output: {
            file: 'dist/utenti.min.js',
            format: 'iife',
            globals: {
                // map library names to global constants
                alpinejs: 'Alpine',
                'fuse.js': 'Fuse',
            },
        },
        plugins: [terser()],
    },
    {
        input: 'src/profilo.js',
        external: ['alpinejs'],
        output: {
            file: 'dist/profilo.min.js',
            format: 'iife',
            globals: {
                alpinejs: 'Alpine',
            },
        },
        plugins: [terser()],
    },
])
